#!/usr/bin/perl

require "setup.pl";

###################################################

read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $input);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$name =~ tr/+/ /;
$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}
###################################################
# Hier JEDES Formularelement eintragen was in dem Formular 
$vname = $FORM{'vname'};
$nname = $FORM{'nname'};
$login = $FORM{'login'};
$email = $FORM{'email'};
$regeln = $FORM{'regeln'};

###################################################
# Liste der Pflichtfelder die der Absender ausfuellen muss. 
# Kann beliebig angepasst werden

# Fehlerbehandlung Anfang
$fehlermeldung = "" ;
$fehler_gefunden = "" ;

$errormeldung = "<li>Der Username existiert schon im System.\n" ;

if (-e "tempuser/$login.dat"){
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Die E-Mail Adresse existiert schon im System.\n" ;

if (-e "tempuser/$email.dat"){
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Das Feld Vorname wurde nicht ausgefllt.\n" ;

if ($vname eq "") {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Das Feld Nachname wurde nicht ausgefllt.\n" ;

if ($nname eq "") {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Das Feld Benutzername wurde nicht ausgefllt.\n" ;

if ($login eq "") {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Der Benutzername darf nur Zeichen von A-Z, a-z, 0-9 und _ enthalten, aber keinerlei Sonderzeichen und Umlaute.\n" ;

if ($login !~ /^[0-9a-zA-Z_]*$/) {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Bitte geben Sie eine gltige E-Mail Adresse ein.\n" ;


if ($email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || 
$email !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/) {

#if ($email !~ /.+\@.+\..+/) {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Das Feld E-Mail wurde nicht ausgefllt.\n" ;

if ($email eq "") {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

$errormeldung = "<li>Das Feld Teilnahmeregeln wurde nicht ausgefllt. Sie mssn die Checkbox Teilnahmeregeln anklicken, nur so kann eine Teilnahme zustandekommen.\n" ;

if ($regeln eq "") {
$fehlermeldung = $fehlermeldung.$errormeldung ;
$fehler_gefunden = 1 ; }

if ($fehler_gefunden) {
&fehlerausgabe; }

# Fehlerbehandlung Ende
###################################################

&datumsausgabe;
&mailsenden; 
&bestaetigung;

sub mailsenden {
open (MAIL, "|$sendmailpfad -t") || die $!;
print MAIL "To: $email ($name)\n";
print MAIL "From: $webmastermail\n";
print MAIL "Subject: Registrierung\n\n";
print MAIL "Hallo $vname $nname,\n\n";
print MAIL "Sie haben sich bei unserem Mitgliederbereich angemeldet.\n";
print MAIL "Unterhalb finden Sie ihre angegebenen Daten.\n";
print MAIL "Name: $vname $nname \n";
print MAIL "Login: $login \n";
print MAIL "E-Mail: $email\n";
print MAIL "Regeln anerkannt: $regeln\n\n";
print MAIL "Bitte klicken Sie nun untenstehenden Link um die Registrierung abzuschlieen.\n";
print MAIL "Sollte der Link nicht vollstndig sein durch einen Zeilenumbruch,\n";
print MAIL "oder Sie empfangen ihre Mails ber einen Freemailservice\n";
print MAIL "so kopieren Sie bitte diesen in die Browseradresszeile und drcken Sie danach die Entertaste.\n\n";
print MAIL "REGISTRIERUNGSLINK:\n\n";
print MAIL "$reglink?action=save&login=$login&email=$email&vname=$vname&nname=$nname\n\n";
print MAIL "Viele Gre\n";
print MAIL "$webmastername\n";
print MAIL "Gesendet um: $datum\n";
close(MAIL);

}
###################################################
sub datumsausgabe {

# Datumsroutine

@tage = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
@monate = ('Januar','Februar','Maerz','April','Mai','Juni','Juli','August',
'September','Oktober','November','Dezember');
($sec, $min, $stunde, $mtag, $mon, $jahr, $tag, $nr_tag, $isdst) = localtime(time);
if($stunde < 10) { $stunde = "0$stunde"; }
if ($min < 10) { $min = "0$min"; }
if ($sec < 10) { $sec = "0$sec"; }
$jahr = 1900 + $jahr;
$datum = "$stunde:$min Uhr $tage[$tag], $mtag. $monate[$mon] , $jahr";
}
###################################################
sub bestaetigung {



open (FILE, ">tempuser/$email.dat");
flock (FILE, 2);
close FILE;
chmod(0777, "tempuser/$email.dat");

open (FILE, ">tempuser/$login.dat");
flock (FILE, 2);
close FILE;
chmod(0777, "tempuser/$login.dat");



print "Content-type: text/html\n\n";
&header;
print qq~
<font size=2 face=verdana, Arial><b>Vielen Dank!</b><br>
Vielen Dank Herr/Frau $vname $nname, fr Ihre Anmeldung.<br><br>
Sie erhalten nun eine Mail mit den Instruktionen wie Sie ihre Mitgliedschaft besttigen.
<br><br>
<a href="$returnurl"><b>Zurck zur Hauptseite</b></a></font></p>
~;
&footer;
}

sub fehlerausgabe {
print "Content-type: text/html\n\n";
&header;
print qq~
<font face="Verdana, Arial" size="2">
<b>Sorry, es wurden Fehler festgestellt bei der Anmeldung</b><br><br>
Beim ausfllen haben Sie folgendes vergessen:<ol> <b>$fehlermeldung</b>
</ol><br><br>
Bitte gehen Sie <a href="javascript:history.go(-1)" onMouseOver="self.status=document.referrer;return true"><b>zurck</b></a> und versuchen es erneut!<br><br>
~;
&footer;
exit;
}

#############################################
# Seitenheader Subroutine
sub header {
# Seitenheader
open (HEADER, "header.html");
flock HEADER, 2;
@header = <HEADER>;
close HEADER;
# Printet die header.html Datei
print "@header\n";
}
#############################################
# Seitenfooter Subroutine
sub footer {
# Seitenfooter
open (FOOTER, "footer.html");
flock FOOTER, 2;
@footer = <FOOTER>;
close FOOTER;
# Printet die footer.html Datei
print "@footer\n";
} 
 

