#!/usr/bin/perl

require "setup.pl";

############################################################

read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $input);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$name =~ tr/+/ /;
$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}
###############################################################
# Formularfeldname des Passwortformulares
$mailadresse = $FORM{'mailadresse'};

# Userdatenbank ffnen
open (FILE,"<tempuser/$mailadresse.dat");
flock(FILE,2);
@users=<FILE>;
flock(FILE,8);
close (FILE);

foreach (@users) # Userdatenbank durchsuchen
{
($email,$user,$passwort,$name)=split(/\|/,$_);
if ($email eq $mailadresse)
{


open (MAIL, "|$sendmailpfad -t") || die $!;
print MAIL "To: $mailadresse\n";
print MAIL "From: $webmastermail\n";
print MAIL "Subject: Ihre Zugangsdaten\n";
print MAIL "Hier ihre Zugangsdaten\n";
print MAIL "User: $user \n";
print MAIL "Passwort: $passwort\n";
print MAIL "Viele Gre\n";
print MAIL "$webmastername\n";
close(MAIL);

$gefunden=1;
}
}
if ($gefunden)
{


print "Content-type: text/html\n\n";
&header;
print qq~
<div align=center>
<font size=2 face=verdana, Arial><b>Userdaten gesendet</b><br>
Ihre Zugangsdaten wurden versendet.<br>
</font></div>
~;
&footer;
} else {

print "Content-type: text/html\n\n";
&header;
print qq~
<div align=center>
<font size=2 face=verdana, Arial color="#ff0000"><b>User nicht gefunden</b><br>
Zu der angegebenen E-Mail Adresse wurden leider keine Daten gefunden.<br>
</font>
~;
&footer;
}
exit;


#############################################
# Seitenheader Subroutine
sub header {
# Seitenheader
open (HEADER, "header.html");
flock HEADER, 2;
@header = <HEADER>;
close HEADER;
# Printet die header.html Datei
print "@header\n";
}
#############################################
# Seitenfooter Subroutine
sub footer {
# Seitenfooter
open (FOOTER, "footer.html");
flock FOOTER, 2;
@footer = <FOOTER>;
close FOOTER;
# Printet die footer.html Datei
print "@footer\n";
}  